﻿using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using HttpClientDICore.Models;

namespace HttpClientDICore.Controllers
{
    [Produces("application/json")]
    [Route("api/[controller]")]
    public class ProductsController : Controller
    {
        private readonly List<Product> _products;

        public ProductsController()
        {
            _products = new List<Product>();
            _products.Add(new Product { ProductId = 1, Name = "Ball", Description = "Round, full of air", Sku = "abc123" });
            _products.Add(new Product { ProductId = 2, Name = "Plate", Description = "Round, flat", Sku = "def456" });
            _products.Add(new Product { ProductId = 3, Name = "Fork", Description = "Pointy", Sku = "ghi789" });
        }

        // GET: api/values
        [HttpGet]
        public async Task<IActionResult> Get()
        {
            return Ok(_products);
        }

        // GET api/values/5
        [HttpGet("{productId}")]
        public async Task<IActionResult> Get(int productId)
        {
            Product product = _products.SingleOrDefault(p => p.ProductId == productId);

            if(product == null)
            {
                return NotFound();
            }
            return Ok(product);
        }
    }
}
