﻿using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using System.Net.Http.Headers;
using System.Net.Http;
using HttpClientDICore.Models;

namespace HttpClientDICore.Controllers
{
    [Produces("application/json")]
    [Route("api/[controller]")]
    public class ValuesController : Controller
    {
        private readonly HttpClient _httpClient;

        public ValuesController(HttpClient httpClient)
        {
            _httpClient = httpClient;
        }

        // GET api/values
        [HttpGet]
        public async Task<IActionResult> Get()
        {
            string requestEndpoint = "api/products";

            HttpResponseMessage httpResponse = await _httpClient.GetAsync(requestEndpoint);
            List<Product> products = await httpResponse.Content.ReasAsJsonAsync<List<Product>>();
            return Ok(products);
        }

        // GET api/values/5
        [HttpGet("{productId}")]
        public async Task<IActionResult> Get(int productId)
        {
            string requestEndpoint = $"products/{productId}";

            HttpResponseMessage httpResponse = await _httpClient.GetAsync(requestEndpoint);

            if (httpResponse.StatusCode != System.Net.HttpStatusCode.OK)
            {
                return NotFound();
            }
            Product product = await httpResponse.Content.ReasAsJsonAsync<Product>();
            return Ok(product);
        }
    }
}
